---------------------
PatchSet 5883 
Date: 2003/08/18 12:13:30
Author: hno
Branch: ssl-2_5
Tag: (none) 
Log:
SSL session reuse

Members: 
	src/forward.c:1.13.6.1.8.4->1.13.6.1.8.5 
	src/structs.h:1.48.2.8.2.5->1.48.2.8.2.6 

Index: squid/src/forward.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/forward.c,v
retrieving revision 1.13.6.1.8.4
retrieving revision 1.13.6.1.8.5
diff -u -r1.13.6.1.8.4 -r1.13.6.1.8.5
--- squid/src/forward.c	7 Aug 2003 14:32:42 -0000	1.13.6.1.8.4
+++ squid/src/forward.c	18 Aug 2003 12:13:30 -0000	1.13.6.1.8.5
@@ -1,6 +1,6 @@
 
 /*
- * $Id: forward.c,v 1.13.6.1.8.4 2003/08/07 14:32:42 hno Exp $
+ * $Id: forward.c,v 1.13.6.1.8.5 2003/08/18 12:13:30 hno Exp $
  *
  * DEBUG: section 17    Request Forwarding
  * AUTHOR: Duane Wessels
@@ -254,6 +254,11 @@
 	    return;
 	}
     }
+    if (fs->peer && !SSL_session_reused(ssl)) {
+	if (fs->peer->sslSession)
+	    SSL_SESSION_free(fs->peer->sslSession);
+	fs->peer->sslSession = SSL_get1_session(ssl);
+    }
     fwdDispatch(fwdState);
 }
 
@@ -293,6 +298,8 @@
 #endif
 	else
 	    SSL_set_ex_data(ssl, ssl_ex_index_server, peer->host);
+	if (peer->sslSession)
+	    SSL_set_session(ssl, peer->sslSession);
     } else {
 	SSL_set_ex_data(ssl, ssl_ex_index_server, fwdState->request->host);
     }
Index: squid/src/structs.h
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/structs.h,v
retrieving revision 1.48.2.8.2.5
retrieving revision 1.48.2.8.2.6
diff -u -r1.48.2.8.2.5 -r1.48.2.8.2.6
--- squid/src/structs.h	7 Aug 2003 14:32:43 -0000	1.48.2.8.2.5
+++ squid/src/structs.h	18 Aug 2003 12:13:30 -0000	1.48.2.8.2.6
@@ -1,6 +1,6 @@
 
 /*
- * $Id: structs.h,v 1.48.2.8.2.5 2003/08/07 14:32:43 hno Exp $
+ * $Id: structs.h,v 1.48.2.8.2.6 2003/08/18 12:13:30 hno Exp $
  *
  *
  * SQUID Web Proxy Cache          http://www.squid-cache.org/
@@ -1345,6 +1345,7 @@
     char *sslflags;
     char *ssldomain;
     SSL_CTX *sslContext;
+    SSL_SESSION *sslSession;
 #endif
     int front_end_https;
 };
